// アキバBlog  blog.livedoor.jp/geek/archives/  (2010-07-09; rentan)
// charset: UTF-8

(function () {


// 右サイドバーを削除
var d = document.getElementById ('links2');
if (d) {
  var r_width = parseInt (d.firstChild.width);
  d.parentNode.removeChild (d);

  var c = document.getElementById ('content');
  var c_width = parseInt (c.currentStyle.width);

  // 削除した右サイドバーの幅だけ、中央部分を広げる
  c.style.width = (c_width + r_width) + 'px';
}


// タグから width height 属性を削除
function removeSize (el) {
  el.removeAttribute ('width');
  el.removeAttribute ('height');
}

// br タグを削除
function removeBr (el) {
  for (var i = el.childNodes.length - 1; i >= 0; --i) {
    var e = el.childNodes [i];

    if (e.nodeName == 'BR') {
//    el.removeChild (e);
      e.replaceNode (document.createTextNode (' '));
    }
    else if (e.hasChildNodes ())
      removeBr (e);
  }
}

// タグから width height 属性を削除して、子ノードから br タグを削除
function removeSizeAndBr (el) {
  removeSize (el);
  try {
    removeBr (el);
  } catch (e) { }
}


// サムネイル画像を原寸画像に差し替える
function expandImage (td) {
  try {
    var img = td.firstChild.firstChild;
    if (img.tagName == 'A')
      img = img.firstChild;

    if (img.src.match (/^(http:\/\/services\.img\d*\.akibablog\.net\/.*)-s(\.jpg)$/)) {
      removeSize (img);
      img.src = RegExp.$1 + RegExp.$2;
    }
  } catch (e) { }
}


// 1行のテーブルでサムネイル画像か？
function is_thumb_table (tb) {
  if (tb.childNodes.length != 1)
    return false;

  // サムネイル画像か？
  var td = tb.childNodes [0].firstChild;
  if (td.firstChild.tagName != 'A'
   || td.firstChild.firstChild.tagName != 'IMG')
    return false;

  return true;
}


// 2行のテーブルで、上がサムネイル画像、下がキャプションか？
function is_thumb_capt_table (tb) {
  if (tb.childNodes.length != 2)
    return false;

  // サムネイル画像か？
  var td = tb.childNodes [0].firstChild;
  if (td.firstChild.tagName == 'DIV')
    td = td.firstChild;
  if (td.firstChild.tagName != 'A'
   || td.firstChild.firstChild.tagName != 'IMG')
    return false;

  // キャプションか？
  td = tb.childNodes [1].firstChild;
  if (td.firstChild.tagName != 'DIV')
    return false;

  return true;
}


// テーブル構造を変更しつつ画像を展開
// ┌───┬───┬───┐
// │画像-A│画像-B│画像-C│
// └───┴───┴───┘
//	↓変換
// ┌───┐
// │画像-A│
// ├───┤
// │画像-B│
// ├───┤
// │画像-C│
// └───┘

function linearize_thumb (tb) {
  var tr_thum = tb.childNodes [0];
  var tr;

  // 最初の tr に td が複数個あれば実行
  // スタイルなどを適用するため createElement ではなく cloneNode を使っている。
  while (tr_thum.childNodes.length > 1) {
    // サムネイル画像を移動
    tr = tr_thum.cloneNode (false);
    tr.appendChild (tr_thum.childNodes [1]);
    expandImage (tr.firstChild);
    tb.appendChild (tr);
  }

  // 最初の画像を展開
  expandImage (tr_thum.firstChild);
}


// テーブル構造を変更しつつ画像を展開
// ┌───┬───┬───┐
// │画像-A│画像-B│画像-C│
// ├───┼───┼───┤
// │説明-A│説明-B│説明-B│
// └───┴───┴───┘
//	↓変換
// ┌───┐
// │画像-A│
// ├───┤
// │説明-A│
// ├───┤
// │画像-B│
// ├───┤
// │説明-B│
// ├───┤
// │画像-C│
// ├───┤
// │説明-C│
// └───┘

function linearize_thumb_capt (tb) {
  var tr_thum = tb.childNodes [0];
  var tr_capt = tb.childNodes [1];
  var tr;

  // 最初の tr に td が複数個あれば実行
  // スタイルなどを適用するため createElement ではなく cloneNode を使っている。
  while (tr_thum.childNodes.length > 1) {
    // サムネイル画像を移動
    tr = tr_thum.cloneNode (false);
    tr.appendChild (tr_thum.childNodes [1]);
    expandImage (tr.firstChild);
    tb.appendChild (tr);

    // キャプションを移動
    tr = tr_capt.cloneNode (false);
    tr.appendChild (tr_capt.childNodes [1]);
    removeSizeAndBr (tr.firstChild);
    tb.appendChild (tr);
  }

  // 最初の画像を展開
  expandImage (tr_thum.firstChild);
  // 最初のキャプションのサイズ調整
  removeSizeAndBr (tr_capt.firstChild);
}


// メイン処理: <table> 内の構造を改変
var table = document.getElementsByTagName ('table');
for (var i = table.length - 1; i >= 0; --i) {
  var tb = table [i].firstChild;
  if (tb == null || tb.tagName != 'TBODY')
    continue;

  if (is_thumb_table (tb))
    linearize_thumb (tb);
  else if (is_thumb_capt_table (tb))
    linearize_thumb_capt (tb);
}


}) ();


// EOF
